﻿Imports Infragistics.Win.UltraWinSchedule
Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.ApptTableAdapter.Fill(Me.AppointmentExampleDataSet.appt)

        'NOTE: By default the BindingContextControl is the form 
        ' - but if you don't set it to None and set it here, you generate a runtime error
        Me.UltraCalendarInfo1.DataBindingsForAppointments.BindingContextControl = Me
    End Sub

    Private Sub UltraDayView1_AfterAppointmentEdited(ByVal sender As System.Object, ByVal e As Infragistics.Win.UltraWinSchedule.AppointmentEventArgs) Handles UltraDayView1.AfterAppointmentEdited
        ApptTableAdapter.Update(AppointmentExampleDataSet.appt)
    End Sub

    Private Sub UltraCalendarInfo1_BeforeDisplayAppointmentDialog(ByVal sender As System.Object, ByVal e As Infragistics.Win.UltraWinSchedule.DisplayAppointmentDialogEventArgs) Handles UltraCalendarInfo1.BeforeDisplayAppointmentDialog
        e.Cancel = True
        If e.IsExistingAppointment And e.Appointment.BindingListIndex >= 0 Then

            Dim appt As AppointmentExampleDataSet.apptRow = DirectCast(e.Appointment.BindingListObject, System.Data.DataRowView).Row
            Dim AppointmentDialog As AppointmentEditForm = New AppointmentEditForm(appt)
            Dim dResult As DialogResult = AppointmentDialog.ShowDialog()
            If dResult = DialogResult.OK Then
                ApptBindingSource.EndEdit()
                ApptTableAdapter.Update(AppointmentExampleDataSet.appt)
            Else
                ApptBindingSource.CancelEdit()
            End If
        Else
            CreateNewAppointment(e.Appointment.StartDateTime, 45)  'create a new 45 minute appointment
        End If

    End Sub

    Private Sub CreateNewAppointment(ByVal StartTime As DateTime, ByVal AppointmentLength As Integer, Optional ByVal practitionerID As Integer = 0)
        Dim appt As Appointment = New Appointment(StartTime, StartTime.AddMinutes(AppointmentLength))
        Dim AppointmentDialog As AppointmentEditForm
        Dim theDataRowView As DataRowView

        'NOTE: Adding the appointment to the calendar will add the row into the dataset
        ' so make sure the TableAdapter in the dataset has default values or allows NULLs for all your columns

        Me.UltraCalendarInfo1.Appointments.Add(appt) 'Add the appointment to the Calendar
        theDataRowView = appt.BindingListObject
        Dim apptDataRow As AppointmentExampleDataSet.apptRow = theDataRowView.Row

        AppointmentDialog = New AppointmentEditForm(apptDataRow)
        Dim dResult As DialogResult = AppointmentDialog.ShowDialog()

        If dResult = DialogResult.OK Then
            ApptBindingSource.EndEdit()
            ApptTableAdapter.Update(AppointmentExampleDataSet.appt)
        Else
            ApptBindingSource.CancelEdit()
            Me.UltraCalendarInfo1.Appointments.Remove(appt)  'remove the appointment from the calendar
        End If
    End Sub
End Class
